Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_impl.hpp	(revision 1875)
@@ -10,7 +10,9 @@
     template <> bool CBuffer::put<short>(const short& data) { return put_template(data) ; }  
     template <> bool CBuffer::put<long>(const long& data)  { return put_template(data) ; }  
+    template <> bool CBuffer::put<longlong>(const longlong& data)  { return put_template(data) ; }  
     template <> bool CBuffer::put<uint>(const uint& data)  { return put_template(data) ; }  
     template <> bool CBuffer::put<ushort>(const ushort& data) { return put_template(data) ; }  
     template <> bool CBuffer::put<ulong>(const ulong& data) { return put_template(data) ; }  
+    template <> bool CBuffer::put<ulonglong>(const ulonglong& data) { return put_template(data) ; }  
     template <> bool CBuffer::put<float>(const float& data) { return put_template(data) ; }  
     template <> bool CBuffer::put<double>(const double& data) { return put_template(data) ; }  
@@ -21,7 +23,9 @@
     template <> bool CBuffer::put<short>(const short* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBuffer::put<long>(const long* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<longlong>(const longlong* data, size_t n)  { return put_template(data,n) ; }  
     template <> bool CBuffer::put<uint>(const uint* data, size_t n)  { return put_template(data,n) ; }  
     template <> bool CBuffer::put<ushort>(const ushort* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBuffer::put<ulong>(const ulong* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBuffer::put<ulonglong>(const ulonglong* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBuffer::put<float>(const float* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBuffer::put<double>(const double* data, size_t n) { return put_template(data,n) ; }  
@@ -33,7 +37,9 @@
     template <> bool CBuffer::put_ptr<short>(const short*& data, size_t n) { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<long>(const long*& data, size_t n)  { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<longlong>(const longlong*& data, size_t n)  { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<uint>(const uint*& data, size_t n)  { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<ushort>(const ushort*& data, size_t n) { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<ulong>(const ulong*& data, size_t n) { return put_ptr_template(data,n) ; }  
+    template <> bool CBuffer::put_ptr<ulonglong>(const ulonglong*& data, size_t n) { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<float>(const float*& data, size_t n) { return put_ptr_template(data,n) ; }  
     template <> bool CBuffer::put_ptr<double>(const double*& data, size_t n) { return put_ptr_template(data,n) ; }  
@@ -46,7 +52,9 @@
     template <> bool CBuffer::get<short>(short& data) { return get_template(data) ; }  
     template <> bool CBuffer::get<long>(long& data)  { return get_template(data) ; }  
+    template <> bool CBuffer::get<longlong>(longlong& data)  { return get_template(data) ; }  
     template <> bool CBuffer::get<uint>(uint& data)  { return get_template(data) ; }  
     template <> bool CBuffer::get<ushort>(ushort& data) { return get_template(data) ; }  
     template <> bool CBuffer::get<ulong>(ulong& data) { return get_template(data) ; }  
+    template <> bool CBuffer::get<ulonglong>(ulonglong& data) { return get_template(data) ; }  
     template <> bool CBuffer::get<float>(float& data) { return get_template(data) ; }  
     template <> bool CBuffer::get<double>(double& data) { return get_template(data) ; }  
@@ -57,7 +65,9 @@
     template <> bool CBuffer::get<short>(short* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBuffer::get<long>(long* data, size_t n)  { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<longlong>(longlong* data, size_t n)  { return get_template(data,n) ; }  
     template <> bool CBuffer::get<uint>(uint* data, size_t n)  { return get_template(data,n) ; }  
     template <> bool CBuffer::get<ushort>(ushort* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBuffer::get<ulong>(ulong* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBuffer::get<ulonglong>(ulonglong* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBuffer::get<float>(float* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBuffer::get<double>(double* data, size_t n) { return get_template(data,n) ; }  
@@ -68,7 +78,9 @@
     template <> bool CBuffer::get_ptr<short>(short*& data, size_t n) { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<long>(long*& data, size_t n)  { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<longlong>(longlong*& data, size_t n)  { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<uint>(uint*& data, size_t n)  { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<ushort>(ushort*& data, size_t n) { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<ulong>(ulong*& data, size_t n) { return get_ptr_template(data,n) ; }  
+    template <> bool CBuffer::get_ptr<ulonglong>(ulonglong*& data, size_t n) { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<float>(float*& data, size_t n) { return get_ptr_template(data,n) ; }  
     template <> bool CBuffer::get_ptr<double>(double*& data, size_t n) { return get_ptr_template(data,n) ; }  
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_decl.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_decl.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_decl.cpp	(revision 1875)
@@ -14,7 +14,9 @@
   macro(short)
   macro(long)
+  macro(longlong)
   macro(uint)
   macro(ushort)
   macro(ulong)
+  macro(ulonglong)
   macro(float)
   macro(double)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_in_impl.hpp	(revision 1875)
@@ -12,7 +12,9 @@
     template <> bool CBufferIn::get<short>(short& data) { return get_template(data) ; }  
     template <> bool CBufferIn::get<long>(long& data)  { return get_template(data) ; }  
+    template <> bool CBufferIn::get<longlong>(longlong& data)  { return get_template(data) ; }  
     template <> bool CBufferIn::get<uint>(uint& data)  { return get_template(data) ; }  
     template <> bool CBufferIn::get<ushort>(ushort& data) { return get_template(data) ; }  
     template <> bool CBufferIn::get<ulong>(ulong& data) { return get_template(data) ; }  
+    template <> bool CBufferIn::get<ulonglong>(ulonglong& data) { return get_template(data) ; }  
     template <> bool CBufferIn::get<float>(float& data) { return get_template(data) ; }  
     template <> bool CBufferIn::get<double>(double& data) { return get_template(data) ; }  
@@ -24,7 +26,9 @@
     template <> bool CBufferIn::get<short>(short* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<long>(long* data, size_t n)  { return get_template(data,n) ; }  
+    template <> bool CBufferIn::get<longlong>(longlong* data, size_t n)  { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<uint>(uint* data, size_t n)  { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<ushort>(ushort* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<ulong>(ulong* data, size_t n) { return get_template(data,n) ; }  
+    template <> bool CBufferIn::get<ulonglong>(ulonglong* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<float>(float* data, size_t n) { return get_template(data,n) ; }  
     template <> bool CBufferIn::get<double>(double* data, size_t n) { return get_template(data,n) ; }  
@@ -36,7 +40,9 @@
     template <> bool CBufferIn::advance<short>(size_t n) { return advance_template<short>(n) ; }  
     template <> bool CBufferIn::advance<long>(size_t n)  { return advance_template<long>(n) ; }  
+    template <> bool CBufferIn::advance<longlong>(size_t n)  { return advance_template<longlong>(n) ; }  
     template <> bool CBufferIn::advance<uint>(size_t n)  { return advance_template<uint>(n) ; }  
     template <> bool CBufferIn::advance<ushort>(size_t n) { return advance_template<ushort>(n) ; }  
     template <> bool CBufferIn::advance<ulong>(size_t n) { return advance_template<ulong>(n) ; }  
+    template <> bool CBufferIn::advance<ulonglong>(size_t n) { return advance_template<ulonglong>(n) ; }  
     template <> bool CBufferIn::advance<float>(size_t n) { return advance_template<float>(n) ; }  
     template <> bool CBufferIn::advance<double>(size_t n) { return advance_template<double>(n) ; }  
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_decl.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_decl.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_decl.cpp	(revision 1875)
@@ -15,7 +15,9 @@
   macro(short)
   macro(long)
+  macro(longlong)
   macro(uint)
   macro(ushort)
   macro(ulong)
+  macro(ulonglong)
   macro(float)
   macro(double)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_out_impl.hpp	(revision 1875)
@@ -11,7 +11,9 @@
     template <> bool CBufferOut::put<short>(const short& data) { return put_template(data) ; }  
     template <> bool CBufferOut::put<long>(const long& data)  { return put_template(data) ; }  
+    template <> bool CBufferOut::put<longlong>(const longlong& data)  { return put_template(data) ; }  
     template <> bool CBufferOut::put<uint>(const uint& data)  { return put_template(data) ; }  
     template <> bool CBufferOut::put<ushort>(const ushort& data) { return put_template(data) ; }  
     template <> bool CBufferOut::put<ulong>(const ulong& data) { return put_template(data) ; }  
+    template <> bool CBufferOut::put<ulonglong>(const ulonglong& data) { return put_template(data) ; }  
     template <> bool CBufferOut::put<float>(const float& data) { return put_template(data) ; }  
     template <> bool CBufferOut::put<double>(const double& data) { return put_template(data) ; }  
@@ -23,7 +25,9 @@
     template <> bool CBufferOut::put<short>(const short* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<long>(const long* data, size_t n)  { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<longlong>(const longlong* data, size_t n)  { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<uint>(const uint* data, size_t n)  { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<ushort>(const ushort* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<ulong>(const ulong* data, size_t n) { return put_template(data,n) ; }  
+    template <> bool CBufferOut::put<ulonglong>(const ulonglong* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<float>(const float* data, size_t n) { return put_template(data,n) ; }  
     template <> bool CBufferOut::put<double>(const double* data, size_t n) { return put_template(data,n) ; }  
@@ -36,7 +40,9 @@
     template <> bool CBufferOut::advance<short>(size_t n) { return advance_template<short>(n) ; }  
     template <> bool CBufferOut::advance<long>(size_t n)  { return advance_template<long>(n) ; }  
+    template <> bool CBufferOut::advance<longlong>(size_t n)  { return advance_template<longlong>(n) ; }  
     template <> bool CBufferOut::advance<uint>(size_t n)  { return advance_template<uint>(n) ; }  
     template <> bool CBufferOut::advance<ushort>(size_t n) { return advance_template<ushort>(n) ; }  
     template <> bool CBufferOut::advance<ulong>(size_t n) { return advance_template<ulong>(n) ; }  
+    template <> bool CBufferOut::advance<ulonglong>(size_t n) { return advance_template<ulonglong>(n) ; }  
     template <> bool CBufferOut::advance<float>(size_t n) { return advance_template<float>(n) ; }  
     template <> bool CBufferOut::advance<double>(size_t n) { return advance_template<double>(n) ; }  
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/context_server.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/context_server.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/context_server.cpp	(revision 1875)
@@ -326,5 +326,6 @@
          // The best way to properly solve this problem will be to use the event scheduler also in attached mode
          // for now just set up a MPI barrier
-         if (!eventScheduler_ && CXios::isServer) MPI_Barrier(intraComm) ;
+//ym to be check later
+//         if (!eventScheduler_ && CXios::isServer) MPI_Barrier(intraComm) ;
 
 //         context->setProcessingEvent() ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_attribute.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_attribute.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/declare_attribute.hpp	(revision 1875)
@@ -42,7 +42,13 @@
       public :                                                    \
          using CAttributeArray<T_num, T_rank>::operator = ;       \
-         name##_attr(void) : CAttributeArray<T_num, T_rank> (#name, *CAttributeMap::Current) {} \
+         bool alwaysFalse=false;\
+         name##_attr(void) : CAttributeArray<T_num, T_rank> (#name, *CAttributeMap::Current) {if (alwaysFalse) TV_ttf_display_type(this);} \
          virtual bool doSend() const { return helper(__VA_ARGS__); }   \
          bool helper(bool returnTrue=true) const { return returnTrue; }   \
+         static int TV_ttf_display_type ( const name##_attr* array )\
+         {\
+           cout<<"TV_ttf_display_type"<<endl ;\
+           return CArray<T_num,T_rank>::TV_ttf_display_type((const CArray<T_num,T_rank>*)array) ;\
+         }\
          virtual ~name##_attr(void) {}                            \
    } name;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_writer_filter.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_writer_filter.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/file_writer_filter.cpp	(revision 1875)
@@ -35,5 +35,5 @@
     }
 
-    field->sendUpdateData(dataArray, client_);
+    field->sendUpdateData(data[0]->timestamp, dataArray, client_);
   }
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/spatial_transform_filter.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/filter/spatial_transform_filter.cpp	(revision 1875)
@@ -174,5 +174,5 @@
         gridTransformation->computeAll(dataAuxInputs, packet->timestamp);
       }
-      packet->data.resize(gridTransformation->getGridDestination()->getDataSize());
+      packet->data.resize(gridTransformation->getGridDestination()->getLocalDataSize());
       if (0 != packet->data.numElements())
         (packet->data)(0) = defaultValue;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template.hpp	(revision 1875)
@@ -72,6 +72,6 @@
          void addChildGroup(V* childGroup) ; 
          static bool dispatchEvent(CEventServer& event) ;
-         void sendCreateChild(const string& id, CContextClient* client) ;
-         void sendCreateChildGroup(const string& id, CContextClient* client) ;
+         void sendCreateChild(const string& id, CContextClient* client, const string& objectId="") ;
+         void sendCreateChildGroup(const string& id, CContextClient* client, const string& objectId="") ;
          static void recvCreateChild(CEventServer& event) ;
          void recvCreateChild(CBufferIn& buffer) ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/group_template_impl.hpp	(revision 1875)
@@ -370,5 +370,5 @@
 
    template <class U, class V, class W>
-   void CGroupTemplate<U, V, W>::sendCreateChild(const string& id, CContextClient* client)
+   void CGroupTemplate<U, V, W>::sendCreateChild(const string& id, CContextClient* client, const string& objectId)
    {
 
@@ -377,5 +377,6 @@
     {
       CMessage msg ;
-      msg<<this->getId() ;
+      if (objectId.empty()) msg << this->getId();
+      else msg << objectId;
       msg<<id ;
       const std::list<int>& ranks = client->getRanksServerLeader();
@@ -388,5 +389,5 @@
 
    template <class U, class V, class W>
-   void CGroupTemplate<U, V, W>::sendCreateChildGroup(const string& id, CContextClient* client)
+   void CGroupTemplate<U, V, W>::sendCreateChildGroup(const string& id, CContextClient* client, const string& objectId)
    {
      CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;
@@ -394,5 +395,6 @@
      {
        CMessage msg ;
-       msg<<this->getId() ;
+       if (objectId.empty()) msg << this->getId();
+       else msg << objectId;
        msg<<id ;
        const std::list<int>& ranks = client->getRanksServerLeader();
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1875)
@@ -575,4 +575,29 @@
    }
 
+   void CAxis::sendAxisToCouplerOut(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid, const string& fieldId, int posInGrid)
+   {
+     if (sendAxisToFileServer_done_.count(client)!=0) return ;
+     else sendAxisToFileServer_done_.insert(client) ;
+     
+     string axisId="_axis["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+
+     if (!axis_ref.isEmpty())
+    {
+      auto axis_ref_tmp=axis_ref.getValue() ;
+      axis_ref.reset() ; // remove the reference, find an other way to do that more cleanly
+      this->sendAllAttributesToServer(client, axisId)  ; 
+      axis_ref = axis_ref_tmp ;
+    }
+    else this->sendAllAttributesToServer(client, axisId)  ; 
+  
+    this->sendAttributes(client, globalDim, orderPositionInGrid, CServerDistributionDescription::BAND_DISTRIBUTION, axisId) ;
+   }
+
+  void CAxis::makeAliasForCoupling(const string& fieldId, int posInGrid)
+  {
+    const string axisId = "_axis["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+    this->createAlias(axisId) ;
+  }
+
   /*!
     Send attributes from one client to other clients
@@ -581,8 +606,8 @@
   */
   void CAxis::sendAttributes(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid,
-                             CServerDistributionDescription::ServerDistributionType distType)
-  TRY
-  {
-     sendDistributionAttribute(client, globalDim, orderPositionInGrid, distType);
+                             CServerDistributionDescription::ServerDistributionType distType, const string& axisId)
+  TRY
+  {
+     sendDistributionAttribute(client, globalDim, orderPositionInGrid, distType, axisId);
 
      // if (index.numElements() == n_glo.getValue())
@@ -590,9 +615,9 @@
          || (index.numElements() != n_glo))
      {
-       sendDistributedAttributes(client);       
+       sendDistributedAttributes(client, axisId);       
      }
      else
      {
-       sendNonDistributedAttributes(client);    
+       sendNonDistributedAttributes(client, axisId);    
      }     
   }
@@ -889,7 +914,8 @@
   */
   void CAxis::sendDistributionAttribute(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid,
-                                        CServerDistributionDescription::ServerDistributionType distType)
-  TRY
-  {
+                                        CServerDistributionDescription::ServerDistributionType distType, const string& axisId)
+  TRY
+  {
+    string serverAxisId = axisId.empty() ? this->getId() : axisId ; 
     int nbServer = client->serverSize;
 
@@ -914,5 +940,5 @@
         msgs.push_back(CMessage());
         CMessage& msg = msgs.back();
-        msg << this->getId();
+        msg << serverAxisId;
         msg << ni << begin;
         msg << isCompressible_;                    
@@ -962,7 +988,9 @@
     In the future, if new attributes are added, they should also be processed in this function
   */
-  void CAxis::sendNonDistributedAttributes(CContextClient* client)
-  TRY
-  {
+  void CAxis::sendNonDistributedAttributes(CContextClient* client, const string& axisId)
+  TRY
+  {
+    string serverAxisId = axisId.empty() ? this->getId() : axisId ; 
+
     CEventClient event(getType(), EVENT_ID_NON_DISTRIBUTED_ATTRIBUTES);
     size_t nbIndex = index.numElements();
@@ -996,5 +1024,5 @@
         msgs.push_back(CMessage());
         CMessage& msg = msgs.back();
-        msg << this->getId();
+        msg << serverAxisId;
         msg << index.getValue() << dataIndex << mask.getValue();
         msg << hasValue;
@@ -1087,7 +1115,9 @@
     In future, if new attributes are added, they should also be processed in this function
   */
-  void CAxis::sendDistributedAttributes(CContextClient* client)
-  TRY
-  {
+  void CAxis::sendDistributedAttributes(CContextClient* client, const string& axisId)
+  TRY
+  {
+    string serverAxisId = axisId.empty() ? this->getId() : axisId ; 
+    
     int ind, idx;
     int nbServer = client->serverSize;
@@ -1166,5 +1196,5 @@
 
       listData.push_back(CMessage());
-      listData.back() << this->getId()
+      listData.back() << serverAxisId
                       << list_indi.back() << list_dataInd.back();
 
@@ -1431,41 +1461,4 @@
   CATCH_DUMP_ATTR
 
-/*!
-  \brief Check if a axis is completed
-  Before make any axis processing, we must be sure that all axis informations have
-  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
-  other context (coupling). So all direct reference of the axis (axis_ref) must be also completed
-  \return true if axis and axis reference are completed
-  */
-  bool CAxis::checkIfCompleted(void)
-  {
-    if (hasDirectAxisReference()) if (!getDirectAxisReference()->checkIfCompleted()) return false;
-    return isCompleted_ ;
-  }
-
-  /*!
-  \brief Set a axis as completed
-   When all information about a axis have been received, the axis is tagged as completed and is
-   suitable for processing
-  */
-  void CAxis::setCompleted(void)
-  {
-    if (hasDirectAxisReference()) getDirectAxisReference()->setCompleted() ;
-    isCompleted_=true ;
-  }
-
-  /*!
-  \brief Set a axis as uncompleted
-   When informations about a axis are expected from a grid reading from file or coupling, the axis is 
-   tagged as uncompleted and is not suitable for processing
-  */
-  void CAxis::setUncompleted(void)
-  {
-    if (hasDirectAxisReference()) getDirectAxisReference()->setUncompleted() ;
-    isCompleted_=false ;
-  }
-
-
-
   /*!
    * Go through the hierarchy to find the axis from which the transformations must be inherited
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.hpp	(revision 1875)
@@ -124,8 +124,4 @@
          bool isEqual(CAxis* axis);
 
-         bool checkIfCompleted(void) ;
-         void setCompleted(void) ;
-         void setUncompleted(void) ;
-
       public: 
         bool hasValue;        
@@ -150,13 +146,21 @@
          std::set<CContextClient*> sendAxisToFileServer_done_ ;
       
+      public:
+         void sendAxisToCouplerOut(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid, const string& fieldId, int posInGrid) ;
+      private:
+         std::set<CContextClient*> sendAxisToCouplerOut_done_ ;
+    
+      public:
+         void makeAliasForCoupling(const string& fieldId, int posInGrid) ;
+
       private:
          void sendAttributes(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid,
-                             CServerDistributionDescription::ServerDistributionType distType);
+                             CServerDistributionDescription::ServerDistributionType distType, const string& axisId="");
          void sendDistributionAttribute(CContextClient* client, const std::vector<int>& globalDim, int orderPositionInGrid,
-                                        CServerDistributionDescription::ServerDistributionType distType);
-         
-
-         void sendNonDistributedAttributes(CContextClient* client);
-         void sendDistributedAttributes(CContextClient* client);
+                                        CServerDistributionDescription::ServerDistributionType distType, const string& axisId="");
+         
+
+         void sendNonDistributedAttributes(CContextClient* client, const string& axisId="");
+         void sendDistributedAttributes(CContextClient* client, const string& axisId="");
 
          static void recvNonDistributedAttributes(CEventServer& event);
@@ -171,12 +175,29 @@
       private:
 
-/** Clients that have to send a domain. There can be multiple clients in case of secondary server, otherwise only one client. */
+/** Clients that have to send a axis. There can be multiple clients in case of secondary server, otherwise only one client. */
          std::list<CContextClient*> clients;
          std::set<CContextClient*> clientsSet;
 
+      private:
          /** define if the axis is completed or not ie all attributes have been received before in case 
              of grid reading from file or coupling */ 
          bool isCompleted_=true ;  
-
+      public:     
+         /*!
+           \brief Check if a axis is completed
+           Before make any axis processing, we must be sure that all axis informations have
+           been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+           other context (coupling). So all direct reference of the axis (axis_ref) must be also completed
+           \return true if axis and axis reference are completed
+          */
+         bool isCompleted(void)
+         {
+           if (hasDirectAxisReference()) if (!getDirectAxisReference()->isCompleted()) return false;
+           else return isCompleted_ ;
+         }
+         void setCompleted(void) { isCompleted_=true ; }
+         void unsetCompleted(void) { isCompleted_=false ; }
+      
+      private:
          bool isChecked;
          bool areClientAttributesChecked_;
